<template>
  <div
    data-component-group="auth-form"
    data-component="confirm-business"
  >
    <ConfirmBusinessNotification
      v-if="isSubmitted && hasConfirmedBusiness"
      :email="email"
      :on-reenter-address="clear"
    />
    <Form
      v-else
      :title="$t('views.register.title')"
    >
      <v-text-field
        v-model="firstName"
        prepend-inner-icon="account_box"
        :label="$t('components.forms.confirm_business.first_name_placeholder')"
        required
        type="text"
        :autofocus="true"
        :error-messages="firstNameErrors"
        @blur="$v.firstName.$touch()"
      />

      <v-text-field
        v-model="lastName"
        prepend-inner-icon="contacts"
        :label="$t('components.forms.confirm_business.last_name_placeholder')"
        required
        type="text"
        :error-messages="lastNameErrors"
        @blur="$v.lastName.$touch()"
      />

      <v-text-field
        v-model="email"
        prepend-inner-icon="mail"
        :label="$t('components.forms.confirm_business.email_placeholder')"
        required
        type="text"
        :error-messages="emailErrors"
        @blur="$v.email.$touch()"
      />

      <VueRecaptcha
        :sitekey="apiKey"
        size="invisible"
        @verify="onVerify"
      />

      <div class="form-actions">
        <v-btn
          flat
          class="trigger register"
          :loading="isLoading"
          @click="submit"
        >
          <v-icon small>
            check
          </v-icon>
          {{ $t('components.forms.confirm_business.submit') }}
        </v-btn>
      </div>
    </Form>
  </div>
</template>

<script>
  import VueRecaptcha from 'vue-recaptcha';
  import { validationMixin } from 'vuelidate';
  import { required, email } from 'vuelidate/lib/validators';
  import colors from 'vuetify/es5/util/colors';
  import Form from '../Form';
  import router from '../../../router';
  import ConfirmBusinessNotification from '../../notifications/auth/ConfirmBusiness';

  export default {
    components: {
      Form,
      ConfirmBusinessNotification,
      VueRecaptcha
    },
    mixins: [validationMixin],
    validations: {
      firstName: {
        required
      },
      lastName: {
        required
      },
      email: {
        required,
        email
      }
    },
    data: () => ({
      firstName: '',
      lastName: '',
      email: '',
      recaptcha: '',
      apiKey: process.env.VUE_APP_RECAPTCHA_KEY,
      isSubmitted: false,
      isLoading: false,
      hasConfirmedBusiness: false,
      colors
    }),
    computed: {
      firstNameErrors() {
        const errors = [];
        if (!this.$v.firstName.$dirty) {
          return errors;
        }
        if (!this.$v.firstName.required) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.first_name_required'));
        }
        return errors;
      },
      lastNameErrors() {
        const errors = [];
        if (!this.$v.lastName.$dirty) {
          return errors;
        }
        if (!this.$v.lastName.required) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.last_name_required'));
        }
        return errors;
      },
      emailErrors() {
        const errors = [];
        if (!this.$v.email.$dirty) {
          return errors;
        }
        if (!this.$v.email.required) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_required'));
        }
        if (!this.$v.email.email) {
          errors.push(router.app.$t('components.forms.confirm_business.errors.email_valid'));
        }
        return errors;
      },
    },
    created() {
      this.$store.watch(() => {
        const hasErrors = this.$store.getters['alerts/error'].length > 0;

        if (this.isSubmitted && hasErrors) {
          this.hasConfirmedBusiness = false;
          this.isSubmitted = false;
          this.isLoading = false;
        }
      }, () => {});
    },
    methods: {
      submit() {
        this.$v.$touch();

        if (!this.canSubmitRequest() || this.$v.$error || this.$v.pending) {
          return false;
        }
        this.sendConfirmRequest();
      },
      clear() {
        this.$v.$reset();
        this.firstName = '';
        this.lastName = '';
        this.email = '';
        this.isSubmitted = false;
        this.isLoading = false;
        this.hasConfirmedBusiness = false;
      },
      canSubmitRequest() {
        return this.firstName !== ''
          && this.lastName !== ''
          && this.email !== ''
          && !this.isSubmitted
          && this.recaptcha !== ''
          && !this.hasConfirmedBusiness;
      },
      sendConfirmRequest() {
        const userDetails = {
          firstname: this.firstName,
          lastname: this.lastName,
          email: this.email.trim(),
          'g-recaptcha-response': this.recaptcha
        };

        this.isSubmitted = true;
        this.isLoading = true;

        return this.$store.dispatch('auth/confirmBusiness', userDetails)
          .then((res) => {
            this.hasConfirmedBusiness = true;
            return res;
          });
      },
      onVerify(res) {
        this.recaptcha = res;
      }
    },
  };
</script>

<style lang="stylus" scoped>
  @import '../../../assets/stylus/theme.styl';

  [data-component-group="auth-form"] {
    &[data-component="confirm-business"] {
      width: 100%;

      .form-actions {
        .trigger.register {
          color: $colors.shades.white;
          background-color: $colors.primary;
          border-radius: 4px;
        }
      }
    }
  }
</style>
